
-- Fendt900 - extended
-- Date 30.10.2016
-- Copyright (C) Slavo LS Modding


fendt900ex = {};

function fendt900ex.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function fendt900ex:load(xmlFile)
	self.cu = false;
	self.uvg = false;
	self.m = 1;
	
	--self.hasVarioGrip = Vehicle.getConfigurationValue(xmlFile, key, wheelnamei, "#VarioGrip", getXMLBool, false, nil, fallbackOldKey);
--
	--if(self.hasVarioGrip) then
	--	print("VarioGrip TRUE");
	--else
	--	print("VarioGrip FALSE");
	--end;

	self.seatID = Utils.indexToObject(self.components, "0>4|1");
	if self.seatID ~=nil then
		self.seatSusp = true;
		local x,y,z = getTranslation(self.seatID);
		self.startSeatXTranslation = x;
		self.startSeatYTranslation = y;
		self.startSeatZTranslation = z;
	else
		self.seatSusp = false;
	end;
	self.seatSusp = false;


	self.variogrip = true;
	self.hasVarioGrip = true;

	self.Switch_iGoPro = false;
	--self.iGopro = Utils.indexToObject(self.components, "0>6|0");

	
	self.podsvietenie = Utils.indexToObject(self.components, "0>4|1|4|1");
	self.variotronic = Utils.indexToObject(self.components, "0>4|1|3|0");
	self.variotronicHUD = Utils.indexToObject(self.components, "0>4|1|2");
	self.svetla = Utils.indexToObject(self.components, "0>13|0|1|3|0");
	self.iHuds = Utils.indexToObject(self.components, "0>4|0|1");

	self.dashoff = Utils.indexToObject(self.components, "0>4|0|3|0");
	self.dashon = Utils.indexToObject(self.components, "0>4|0|3|1");
	self.dashlight = Utils.indexToObject(self.components, "0>4|0|3|2");

	print("  Fendt 900 extended by Slavo LS Modding");
		setVisibility(self.dashoff, true);
	setVisibility(self.dashon, false);
	setVisibility(self.dashlight, false);

	self.suspFront = self.wheels[1].suspTravel;
	self.suspBack = self.wheels[3].suspTravel;

	self.deformFront = self.wheels[1].maxDeformation;
	self.deformBack = self.wheels[3].maxDeformation;

	self.frictionFront = self.wheels[1].frictionScale;
	self.frictionBack = self.wheels[3].frictionScale;
end;

function fendt900ex:delete()
end;

function fendt900ex:readStream(streamId, connection)
end;

function fendt900ex:writeStream(streamId, connection)
end;

function fendt900ex:mouseEvent(posX, posY, isDown, isUp, button)
end;

function fendt900ex:keyEvent(unicode, sym, modifier, isDown)
end;

function fendt900ex:update(dt)
	if InputBinding.hasEvent(InputBinding.iLight) then
		self.Switch_iLight = not self.Switch_iLight;
		setVisibility(self.iLight, self.Switch_iLight);
	end;

	--if InputBinding.hasEvent(InputBinding.iGoPro) then
	--	self.Switch_iGoPro = not self.Switch_iGoPro;
	--	self.cu = true;
	--end;

	if self.isMotorStarted then
		if(self.seatSusp) then
			setTranslation(self.seatID, self.startSeatXTranslation, self.startSeatYTranslation+self.wheels[4].deltaY, self.startSeatZTranslation);
		end;

		if InputBinding.hasEvent(InputBinding.VarioGrip) then
			if (self.hasVarioGrip) then
				self.variogrip = not self.variogrip;
				self.uvg = true;
				if (self.variogrip) then t = 5; else t = 1; end;
			end;
		end;

		if(self.uvg == true) then
		    for i, wheel in ipairs(self.wheels) do
		    	if(self.variogrip) then

		    		if(self.deformFront*t > wheel.maxDeformation) then
		    			self.m = self.m+0.001;

			    		if((i == 1) or (i == 2)) then
			    			wheel.maxDeformation = self.deformFront*self.m;
			    			wheel.frictionScale = self.frictionFront*self.m;
			    		else 
			    			wheel.maxDeformation = self.deformBack*self.m;
			    			wheel.frictionScale = self.frictionBack*self.m;
			    		end;
			    		wheel.suspTravel = wheel.suspTravel - (self.m / 10000);
			    		self:updateWheelTireFriction(wheel);
			    		self:updateWheelBase(wheel);
			    	else
			    		self.uvg = false;
		    		end;
		    	else
		    		if(self.deformFront*t < wheel.maxDeformation) then
		    			self.m = self.m-0.001;

			    		if((i == 1) or (i == 2)) then
			    			wheel.maxDeformation = self.deformFront*self.m;
			    			wheel.frictionScale = self.frictionFront*self.m;
			    		else 
			    			wheel.maxDeformation = self.deformBack*self.m;
			    			wheel.frictionScale = self.frictionBack*self.m;
			    		end;
			    		wheel.suspTravel = wheel.suspTravel + (self.m / 10000);
			    		self:updateWheelTireFriction(wheel);
			    		self:updateWheelBase(wheel);
		    		else 
						self.uvg = false;
		    		end;
		    	end;
			end;

		end;
	end;

end;

function fendt900ex:updateTick(dt)

	--if(self.cu == true) then
	--	if(self.Switch_iGoPro) then
	--		self.vCamera = getCamera();
	--		VehicleCamera:resetCamera();
	--		setCamera(self.iGopro);
	--		self.cu = false;
	--	else
	--		VehicleCamera:resetCamera();
	--		setCamera(self.vCamera);
	--		self.cu = false;
	--	end;
	--end;
   if self:getIsActive() then
		if self.isMotorStarted then
			setVisibility(self.dashoff, false);
			setVisibility(self.iHuds, true);
			setVisibility(self.dashon, true);
			setVisibility(self.podsvietenie, true);
			setVisibility(self.variotronic, true);
			setVisibility(self.variotronicHUD, true);
			if( getVisibility(self.svetla) == true ) then
				setVisibility(self.dashlight, true);
			else
				setVisibility(self.dashlight, false);
			end;
		else
			setVisibility(self.iHuds, false);
			setVisibility(self.dashoff, true);
			setVisibility(self.dashon, false);
			setVisibility(self.dashlight, false);
			setVisibility(self.podsvietenie, false);
			setVisibility(self.variotronic, false);
			setVisibility(self.variotronicHUD, false);
		end;
	end;
end;

function fendt900ex:draw()
end;

function fendt900ex:onLeave()
end;

function fendt900ex:onEnter()
end;